<?php

  dl('php_mapscript.so');
  $available_scale = array(25000, 50000, 10000, 200000, 500000, 1000000, 
                           1400000, 2000000, 4000000, 6000000);  
  
  $scale_index = ( isset($_POST['scale_index']) ? $_POST['scale_index'] : 7);
  $min_scale_index = 0;
  $max_scale_index = count($available_scale)-1;
 
  $Map = ms_newMapObj('/var/www/test3/mapfiles/mapfile_1.map');
  
  // to keep the extent set inmapfile as is set as reference
  $mapfile_extent = ms_newRectObj();
  $mapfile_extent->setextent($Map->extent->minx,
                             $Map->extent->miny,
                             $Map->extent->maxx,
                             $Map->extent->maxy );
  
  if (!isset($_POST['image_height']))
  {
     $image_width=$Map->width;
     $image_height=$Map->height;
     $old_image_width=$image_width;
     $old_image_height=$image_height;
  }
  else
  {  
     $old_image_width=$_POST['old_image_width'];
     $old_image_height=$_POST['old_image_height'];
     $image_width=$_POST['image_width'];
     $image_height=$_POST['image_height'];
  }
  
  //before command extent
  $before_extent = ms_newRectObj();
  if (!isset($_POST['minx']))
  {
      $before_extent = $mapfile_extent;
  }
  else
  {
      $before_extent->setextent($_POST['minx'],$_POST['miny'],
                                $_POST['maxx'],$_POST['maxy']);
  }
 
  $point_click = ms_newPointObj();
  $point_click->setXY($_POST[map_x],$_POST[map_y]);
  
  
  $Map->set( 'width', $image_width); 
  $Map->set( 'height', $image_height); 

  switch ($_POST['cmd_tools']) 
  {
    case 'zoom_in':
        $scale_index=max($min_scale_index,$scale_index-1);        
        $scale = $available_scale[$scale_index];
        $Map->zoomscale($scale, $point_click, $old_image_width, 
                        $old_image_height, $before_extent, $before_extent);
        break;
    case 'zoom_out':
        $scale_index=min($max_scale_index,$scale_index+1);
        $scale = $available_scale[$scale_index];
        $Map->zoomscale($scale, $point_click, $old_image_width, 
                        $old_image_height,  $before_extent, $mapfile_extent);
        break;
    case 'pan':
        $scale = $available_scale[$scale_index];
        $Map->zoomscale($scale, $point_click, $old_image_width, 
                        $old_image_height,  $before_extent, $mapfile_extent);
        break;
  } 
  
  $map_img = $Map->draw(); 
  $extent_img = $Map->drawReferenceMap(); 
  $after_scale = $Map->scale; 
  $after_extent = $Map->extent;
  $main_map =  $map_img->saveWebImage();  
  $reference_map =  $extent_img->saveWebImage();

  $image_ratio = $image_width/$image_height;
  $mapfile_extent_ratio = ($mapfile_extent->maxx - $mapfile_extent->minx)/
                          ($mapfile_extent->maxy - $mapfile_extent->miny); 
  $map_ratio = ($Map->extent->maxx - $Map->extent->minx)/
               ($Map->extent->maxy - $Map->extent->miny);

  if (!isset($_POST['scale'])) $_POST['scale'] = $after_scale;
  if (!isset($_POST['cmd_tools'])) $_POST['cmd_tools'] = 'zoom_in';
?>

<html>
<head>
<title>Test zoomscale bug</title>
</head>

<body>
<form action="<?php echo $_server['PHPSELF']?>" method="POST" name="zoom_scale">
Map:<br>
<input type="radio" name="cmd_tools" value="zoom_in" <?php echo $_POST['cmd_tools'] == 'zoom_in' ? 'checked' : '' ?> >
Zoom in
<input type="radio" name="cmd_tools" value="zoom_out" <?php echo $_POST['cmd_tools'] ==  'zoom_out' ? 'checked' : '' ?> >
Zoom out
<input type="radio" name="cmd_tools" value="pan" <?php echo $_POST['cmd_tools'] ==  'pan' ? 'checked' : '' ?> >
Pan<br>
width: <input type="text" name="image_width" value="<?php echo $image_width ?>">
height: <input type="text" name="image_height" value="<?php echo $image_height ?>">
<br>
<input type="image" src="<?php echo "$main_map"?>" name="map">
<img src="<?php echo "$reference_map"?>">
<input type="hidden" name="scale_index" value="<?php echo $scale_index ?>">
<input type="hidden" name="minx" value="<?php echo $Map->extent->minx ?>">
<input type="hidden" name="miny" value="<?php echo $Map->extent->miny ?>">
<input type="hidden" name="maxx" value="<?php echo $Map->extent->maxx ?>">
<input type="hidden" name="maxy" value="<?php echo $Map->extent->maxy ?>">
<input type="hidden" name="old_image_width" value="<?php echo $Map->width ?>">
<input type="hidden" name="old_image_height" value="<?php echo $Map->height ?>">

</form>
<?php
echo "<br>Extent in mapfile: " . $mapfile_extent->minx . ' ' . $mapfile_extent->miny . ' ' 
                               . $mapfile_extent->maxy . ' ' . $mapfile_extent->maxy;
echo "<br>Extent before command: " . $before_extent->minx . ' ' . $before_extent->miny . ' ' 
                                   . $before_extent->maxy . ' ' . $before_extent->maxy;
echo "<br>Asked scale: " . $available_scale[$scale_index];
echo "<br>Scale after command: $after_scale";
echo "<br>Ratio image: $image_ratio";
echo "<br>Ratio mapfile extent: $mapfile_extent_ratio";
echo "<br>Ratio fo this map: $map_ratio";


//phpinfo();
?>
</body>

</html>
